aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/functions.sh
diff options
context:
space:
mode:
authorMauro Sardara <msardara@cisco.com>2022-08-16 09:43:05 +0200
committerMauro Sardara <msardara@cisco.com>2022-08-17 17:58:36 +0200
commit309fafddc51697deb9c6f8bf723c10539224cb4d (patch)
tree5f50208043312c0ec0a7680d8ff2fc70f497085c /scripts/functions.sh
parent7f18fb8e83a9cd4d32b6bf0eb39503cf2f551b4a (diff)
ci(functional-tests): add functional tests scripts
- Add scripts/functional-tests.sh script - Add `download_artifacts` functions, allowing to retrieve artifacts of a gerrit patch - Robot: redirect output of topology build to files, thus preventing robot from hanging - Share folders between host and containers with the :z flag - Use sudo to install executable in docker-compose scripts, as the user of the docker is not root anymore - Makefile: decouple installation and build Ref: HICN-732 Change-Id: Ib945cf7bd0ee331e33270cf1005dfebd085862eb Signed-off-by: Mauro Sardara <msardara@cisco.com>
Diffstat (limited to 'scripts/functions.sh')
-rw-r--r--scripts/functions.sh46
1 files changed, 44 insertions, 2 deletions
diff --git a/scripts/functions.sh b/scripts/functions.sh
index 147f6669c..06673f888 100644
--- a/scripts/functions.sh
+++ b/scripts/functions.sh
@@ -56,8 +56,6 @@ function call_once() {
# Install dependencies
function install_deps() {
- curl -fsSL https://get.docker.com -o get-docker.sh
- sudo sh get-docker.sh
make -C ${SCRIPT_PATH}/.. deps
}
@@ -75,3 +73,47 @@ function setup_extras() {
call_once install_deps
call_once install_collectd_headers
}
+
+# Download artifacts of this patchset from jenkins
+function download_artifacts() {
+ if [[ -n ${GERRIT_HOST:-} ]] &&
+ [[ -n ${GERRIT_CHANGE_NUMBER:-} ]] &&
+ [[ -n ${GERRIT_PATCHSET_NUMBER:-} ]]; then
+
+ # Retrieve the Jenkins URL of the build relative to this PATCHSET
+ JENKINS_URL=$(
+ curl -s "https://${GERRIT_HOST}/r/changes/${GERRIT_CHANGE_NUMBER}/detail" |
+ tail -n +2 | jq '.messages[].message?' |
+ grep -E "Patch Set ${GERRIT_PATCHSET_NUMBER}:.*hicn-verify-build.*build_success-hicn-ubuntu2004-$(uname -m)" |
+ grep -Eo "https?://jenkins.fd.io/job/hicn-verify-build-hicn-ubuntu2004-$(uname -m)[^ ]+"
+ )
+ ARTIFACTS_URL="${JENKINS_URL}/artifact/packages/*zip*/packages.zip"
+
+ # Download artifacts
+ curl -o "${SCRIPT_PATH}/../packages.zip" -L "${ARTIFACTS_URL}"
+
+ # Unzip them
+ unzip "${SCRIPT_PATH}/../packages.zip" -d "${SCRIPT_PATH}/.."
+ else
+ echo "GERRIT_* environment is not set. Impossible to download artifacts." >&2
+ exit 1
+ fi
+}
+
+# Run functional tests
+function functional_test() {
+ echo "*******************************************************************"
+ echo "********************* STARTING FUNCTIONAL TESTS *******************"
+ echo "*******************************************************************"
+
+ download_artifacts
+
+ # Run functional tests
+ pushd ${SCRIPT_PATH}/../tests
+ BUILD_SOFTWARE=0 DOCKERFILE="tests/Dockerfile.ci" bash ./run-functional.sh
+ popd
+
+ echo "*******************************************************************"
+ echo "********** FUNCTIONAL TESTS COMPLETED SUCCESSFULLY ***************"
+ echo "*******************************************************************"
+}